
#coding:utf-8
#July, 2021. Ikueikan University (Wakkanai Hokusei Gakuen University) 
#

import socket
import sys
import os

import time
import threading
import queue
from concurrent.futures import ThreadPoolExecutor 


class SendThread (threading.Thread):
  def __init__(self, name, threadLock):
      threading.Thread.__init__(self)
      self.name = name
      self.que = queue.Queue()
      self.threadLock = threadLock
  def run(self):
    self.read_file()
    global flag
    global pingpong#送信と受信を交互にする
    print("Starting " + self.name)
    print("Command number:" + str(self.que.qsize()))
    while self.que.qsize()>0:
      if pingpong == True:
        self.threadLock.acquire()
        self.send_msg()
        self.threadLock.state=True
        self.threadLock.notify()
        self.threadLock.release()
        pingpong = False
            
    print("Ending " + self.name)
    flag = False

  def read_file(self):
    f=open('command.txt','r')
    list = f.readlines()
    for data in list:
        self.que.put(data)
  
  def send_msg(self):
    msg = self.que.get()
    print("send a command")
    print(msg)
    exec(msg)
    if 'land' in msg:
        print('flag change')           
        flag =False

                
class RecThread (threading.Thread):
  def __init__(self, name, socket, threadLock):
    threading.Thread.__init__(self)
    self.name = name 
    self.socket = socket
    self.threadLock = threadLock
        
  def recv_msg(self):
      recv_msg = self.socket.recv(1024)
      if not recv_msg:#recv_msgが空であれば、プログラムの終了
        sys.exit(0)
      recv_msg = recv_msg.decode()
      print(recv_msg)
  
  def run(self):
    global flag
    global pingpong
    print("Starting " + self.name)
    while flag:

      if pingpong == False:# Trueのときレシーブ
        # Get lock to synchronize threads
        self.threadLock.acquire()
        self.recv_msg()
        self.threadLock.state=False
        # Free lock to release next thread
        self.threadLock.notify()
        self.threadLock.release()
        pingpong = True
    print("Ending " + self.name)
    self.socket.close()


#各種設定
host = ''
port = 8889
locaddr = (host,port) 






EXECUTE = True

while EXECUTE:
  flag = True
  pingpong = True
  threadLock = threading.Condition()
  
  # Create a UDP socket
  socket1 = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)

  tello_address = ('192.168.10.1', 8889)

  socket1.bind(locaddr)

  print("Waiting for connections")

  # Create new threads
  thread1 = RecThread("receive-Thread", socket1, threadLock)
  thread2 = SendThread( "send-Thread", threadLock)

  # Start new Threads
  thread1.start()
  thread2.start()
  thread1.join()
  thread2.join()

  while True:
    txt=input("execute a command.txt again？Y/N")
    if txt == "Y" or txt =='y':
      while True:
        key = input("Edit the command.txt，then please push the Enter")
        if not key:break
      break
    elif txt == 'N' or txt =='n':
      print('Finished!')
      EXECUTE = False
      break
    else:
      print("please input a Y or N key")
